#cython: language_level=3

from obitools3.apps.optiongroups import addMinimalInputOption
from obitools3.uri.decode import open_uri
from obitools3.dms import DMS

 
__title__="Less equivalent"
 

def addOptions(parser):

    addMinimalInputOption(parser)
 
    group=parser.add_argument_group('obi less specific options')
 
    group.add_argument('--print', '-n',
                     action="store", dest="less:print",
                     metavar='<N>',
                     default=10,
                     type=int,
                     help="Print N entries (default: 10)")
 

def run(config):
    
    cdef object entries
    cdef int    n
    
    DMS.obi_atexit()
    
    input = open_uri(config['obi']['inputURI'])
       
    entries = input[1]
    
    if config['less']['print'] > len(entries) :
        n = len(entries)
    else :
        n = config['less']['print']
        
    # Print
    for i in range(n) :
        print(repr(entries[i]))

